/*
	Write & edit by Linjianghua(Xempo) 2004-2006, 2008-2011
	Copyright Linjianghua(Xempo)
	Reserve all rights this file
*/
/* ver format: x.x.x */

const char FileFmt[24]={'R','u','n','t','i','m','e','-','l','i','b',32,
'V','2','.','5','.','0',13,10,26},
/* use last 8 byte as ver tag, {13,10,26} is end flag */
libCode[]="RTL Kernel2.6.0, free",
ExtRTL[]=".rtl";

#include "rtlproj.h"
#include "normlib.h"

int idxdscpt;

#ifndef _K_RUNTIME_
RunTimLib *LibCmpr;
#endif

#define DAUsave  4

void *zalloc(unsigned int sz)
{
void *mem=malloc(sz);
if(mem==NULL)puts("Fail to alloc memory");
else memset(mem, 0, sz);
return mem;
}

void FreeMAU(MAU *send,int n)
{
int i;
for(i=0;i<n;i++)if(send[i].buf)free(send[i].buf);
}

void dkwrite(RunTimLib *lib,_Long pos,void *dat,size_t len)
{
  fseek(lib->fpt,/*pos<1? lib->statpos-pos:*/pos,0);
  fwrite(dat,len,1,lib->fpt);
}

size_t dkread(RunTimLib *lib,_Long pos,void *dat,size_t len, size_t cn)
{
  fseek(lib->fpt,pos,0);
  return fread(dat,len,cn,lib->fpt);
}

void AppCSB(RunTimLib *lib,DIRE *dir,size_t len,void *lnk,size_t off)
{
  BYTE *dat=(BYTE *)zalloc(len);
  if(dat){
	if(lnk)memcpy(dat+len-off,lnk,off);
	dkwrite(lib,lib->fsz,dat,len);
	free(dat);
	lib->fsz+=len;
	lib->usesize+=len;
	if(dir)dir->sz+=len;
	}
}

void SetChgflg(RunTimLib *lib,DIRE *dir,int step,int dirflg)
{
DirShadow *pdp=GetDirShadow(dir,lib);
pdp->mdf|=dirflg;
pdp->selfnumb+=step;
lib->tolNumb+=step;	lib->mdf|=1;
}

_Long *GetLenDAU(DirShadow *pdp,BYTE *stat,
		un_Int *len,un_Int *tlen, int idx)
{
  BYTE *daupos=StatDAU(pdp,stat,idx);
  *tlen=*(un_Int *)daupos;
  *len=*(un_Int *)(daupos+sizeof(un_Int));
  return (_Long *)(daupos+sizeof(un_Int)*2);
}

/* sw: 0 is tLen, 1 is len */
static void SetLenDAU(DirShadow *pdp,BYTE *stat, un_Int len, int idxdau, int sw)
{
  BYTE *dau=StatDAU(pdp,stat,idxdau);
  *(un_Int *)(dau+sizeof(un_Int)*sw)=len;
}

#define LenCmp(sendLen,len) (sendLen<len && len-sendLen<200)

#ifndef _NONE_FAST_PAGE_
static void SetPgBuf(RunTimLib *lib,DIRE *dir,zdivPage *PageBuff,_Long Seg,_Long _numb_cur)
{
if(_numb_cur>0){
  _Int b, idx;
  zdivPage *bufptr;
  for(b=0;b<PageBufSiz;b++)
	if(PageBuff[b].pCSB==Seg)return;
  if(lib->pg_use<PageBufSiz)idx=lib->pg_use++;
  else {
	idx=0;	lib->pg_use=1;
	}	
  bufptr=PageBuff+idx;
  bufptr->pDIRE=dir? dir->pOwn:20;
  bufptr->pCSB=Seg;
  bufptr->_numb_=_numb_cur;
 }
}
#endif

void chgsize(RunTimLib *lib,DIRE *dir,BYTE *unit,_Int step,_Int idx)
{
  un_Int len, tlen;
  GetLenDAU(GetDirShadow(dir,lib),unit,&len,&tlen,idx);
  if(dir)dir->sz+=(_Long)len*step;
  lib->usesize+=(_Long)len*step;
}

BYTE *StatSeek(RunTimLib *lib,DIRE *dir,_Long nmb,void *dirnam,int _Msg)
{
un_Int len, clen;
int msg=_Msg&~(NUMB_SYS_ID|FREE_READ),
cnt_unit, style, /* perhan cnt_unit*clen>255, tcc would flow bit */
i, n, zero=0, cn_dacu=0,
info=msg&255; /* msg>510 is dir, nor nmb */
DirShadow *pdp;
CSB_Unit *vStat, *dirloop;
BYTE *CSB_buf=NULL, *pStat, *pUnit, nmbpos,
/* ----- numb stat style ---- */
 Flag;
 _Long numb,
/* ----- stylemember ------ */
 NUMB, Numb_Cnt, dflen,
 *ptr, Seg, csbadr, numbcnt;
#ifndef _NONE_FAST_PAGE_
_Long  pgbuf_div, pg_cnt;
zdivPage *PageBuff;
#endif

RTLisNull(lib)

lib->statpos=0;/* init every call */
idxdscpt=0x7fff; /* no-error code */
if(_Msg&NUMB_SYS_ID){
	pdp=(DirShadow *)&lib->mdf;
	dirloop=dgetcsb_u(pdp);
	vStat=sys_ngetcsb_u(lib);
}
else {
	pdp=GetDirShadow(dir,lib);
	dirloop=dgetcsb_u(pdp);
	vStat= msg>510? dirloop:ngetcsb_u(pdp);
}

style=pdp->Format;
Seg=info!=RTL_STAT_BLANK? vStat->cur_CSB:vStat->nx_CSB;
cnt_unit=vStat->cnt_unit;
if(info==RTL_WRITE)lib->msg_OL=0;
if(msg>510)clen=d_statLen;
else{
     clen=pdp->n_statLen;
     n=pdp->_DAU;
     zero=isZero(style);
     if(zero){	Numb_Cnt=0;	numbcnt=0;
#ifndef _NONE_FAST_PAGE_
          if(msg!=NUMB_STAT_BLANK){/* read page-buff */
	PageBuff=lib->zdpbuf;
	NUMB=0x7fffffff;
	for(n=-1,i=PageBufSiz;i>-1;i--)
	  if(PageBuff[i].pCSB>0&&
	     (dir&&PageBuff[i].pDIRE==dir->pOwn||dir==NULL&&PageBuff[i].pDIRE==20)
		){
		numb=nmb - PageBuff[i]._numb_;
		if(numb>-1 && NUMB>numb){ NUMB=numb; n=i; }
		}
	if(n>-1){
	  Seg=PageBuff[n].pCSB;
	  Numb_Cnt=PageBuff[n]._numb_;
	}
	pgbuf_div=(nmb-Numb_Cnt)/PgBufDivLen;  /* n+1, fit to redure scndsk */
	if(pgbuf_div==0)pgbuf_div=1;
	pg_cnt=0;
	}
#endif
	lib->CSB_calc=Numb_Cnt/cnt_unit;
	}
	else {	nmbpos=statNumPos;
#ifndef _K_RUNTIME_
		if(LibCmpr==lib)Seg=vStat->nx_CSB;/* for compress */
#endif
		} 
     if(msg!=NUMB_STAT_BLANK)pdp->_numb_=nmb;
     else pdp->c_CSB_numb=Seg;
  }

if(msg!=NUMB_LAST){
	if((pUnit=(BYTE *)zalloc(clen))==NULL)goto failmem;
	}
else pUnit=NULL;

len=cnt_unit*clen+sizeof(_Long);
if(Seg==0)
   if(info==RTL_WRITE){
	vStat->cur_CSB=lib->fsz;
#ifndef _K_RUNTIME_
	if(lib==LibCmpr)vStat->nx_CSB=lib->fsz;
#endif
	lib->LNKDWORD=lib->fsz;
	return pUnit;
	}
   else { idxdscpt=msg>510? I_NoDir:I_NoNumb;
	goto rt1;
	}

if((CSB_buf=(BYTE *)malloc(len))==NULL){ 
 failmem: idxdscpt=I_FAIL_MEM; goto rt1;
}
ptr=(_Long *)(CSB_buf+len-sizeof(_Long));
while( Seg>0 ){
   if(dkread(lib,Seg,CSB_buf,len,1)<1){	/* file error */
	idxdscpt=ErrScnFile;	break;
	}
/* #ifndef _K_RUNTIME_ no set here, for search */
 if(info==RTL_STAT_BLANK){
	vStat->nx_CSB=*ptr; 
rt1: free(pUnit); return CSB_buf;
 }
/*#endif*/

 if(zero){
	NUMB = Numb_Cnt + cnt_unit;
#ifndef _NONE_FAST_PAGE_
	pg_cnt+=cnt_unit;
	if(pg_cnt>=pgbuf_div/*&&pgflag&&lib->pg_use<_PgBufSiz*/){
		SetPgBuf(lib,dir,PageBuff,Seg,Numb_Cnt);
		pg_cnt=0;
		}
#endif

	if(NUMB<=nmb){
	  if(*ptr<1)csbadr=Seg+len-4;
	  Numb_Cnt=NUMB;
	  goto loop;
	  }

  }
#ifndef _K_RUNTIME_
  else if(LibCmpr==lib)vStat->nx_CSB=Seg; /* for compress */
#endif

  for(i=0,pStat=CSB_buf, csbadr=Seg; i<cnt_unit; i++,csbadr+=clen,pStat+=clen){
    Flag=*pStat;
    numb=msg>510? stricmp((char *)dirnam,((DirStat *)pStat)->name):
    (zero? Numb_Cnt++ : *(_Long *)(pStat+nmbpos) );
    switch(Flag){
    case 1 :
      if(msg==NUMB_LAST){/* only Zero, but here not limit, as when input(con) ought to denied */
	if(++numbcnt>=pdp->selfnumb){
		pdp->_numb_=Numb_Cnt; 
		goto outloop; 
		}
	continue;
	}
      if(nmb==numb){
	switch(info){/* find it */
	case RTL_WRITE : 
		if(msg>510)idxdscpt=I_DupNam; /* dir */
		else { idxdscpt=I_OverWriteN;	lib->msg_OL=1; }
	case RTL_DEL :
	case RTL_REN : 
	case RTL_READ : 
	case RTL_BROW :	_get_dat_: memcpy(pUnit,pStat,clen);
	case RTL_STAT_POS :
	 skp1:  lib->statpos=csbadr;
	   goto outloop;
		}/* find it */
	   }
	break;/* useful */
    case 0 : 	/* follow is dat->Flags=0 */
	switch(info){
	case RTL_WRITE :
		if(zero){
			if(nmb==numb)goto _get_dat_;
			}
	        else {
	#ifndef _K_RUNTIME_
			if(LibCmpr==lib)goto skp1;
	#endif
			if(lib->statpos==0)lib->statpos=csbadr;
			}
		break;
	case RTL_READ : if(zero&&numb>=nmb)goto outloop;
		}
	break;	/* msg=0; only init */
    default : switch(info){/* unuseful,  !!zero have tried OPM */
	case RTL_WRITE : 
	  if(zero){
		if(numb==nmb)goto _get_dat_;
		}
	  else if(msg>510){
		  if(lib->statpos==0){
		     memcpy(pUnit,pStat,clen);
		     lib->statpos=csbadr; /* unit-pos which will write */
		  }
		}
		else {
			un_Int tlen, len, df;
			_Int b=0, c;
			_Long cnt_df=0;
			MAU *send=(MAU *)dirnam;
			for(c=0; c<n; c++){
			  GetLenDAU(pdp,pStat,&len,&tlen,c);
			  if(send[c].len<=tlen){
				df=tlen-send[c].len;
				if(df>2048&&send[c].len<3000)goto noRe;
				b++; cnt_df+=df;
				}
			 }
			if(b>cn_dacu){
				cn_dacu=b;
				setval:lib->statpos=csbadr;
				dflen=cnt_df;
				memcpy(pUnit,pStat,clen);
				}
			else if(b>0&&b==cn_dacu&&cnt_df<dflen||
				lib->statpos==0&&n>1)goto setval;
		}
	noRe:break;
	case RTL_RESCUE : goto _get_dat_;
/*	case NUMB_READ : goto outloop; perhan many same name or nmb data is unuse*/
	}/* sw Flag!=0 */
    }/* end sw-Flag */
}/* for-loop */
loop: lib->CSB_calc++;	Seg=*ptr;
}/* while-loop */
outloop:free(CSB_buf);
if(lib->statpos==0){
	switch(info){
	case RTL_BROW :
	case RTL_REN :
	case RTL_READ :
	case RTL_DEL :
	case RTL_STAT_POS : idxdscpt=dirnam ? I_NoDir : I_NoNumb;
	case RTL_RESCUE : 
		free(pUnit);
		return NULL;
	case RTL_WRITE : if( idxdscpt>0x7ffd )lib->LNKDWORD=csbadr;
	}
}
return pUnit;
}

char *ReadDAU(RunTimLib *lib, DIRE *dir, BYTE *unit, MAU *send, int idx)
{
if(send && unit/* &&*unit==1, reuse-func in future */){
 size_t cn;
 un_Int len, tlen;
 _Long *adr=GetLenDAU(GetDirShadow(dir,lib),unit,&len,&tlen,idx);
 if(len==0)send->buf=NULL;
 else {
   send->buf=(char *)malloc( len + 2 );
   if(send->buf==NULL){ idxdscpt=I_FAIL_MEM; return NULL; }
   if(len<=DAUsave&&tlen<=DAUsave){
	memcpy(send->buf,  adr, len);
	cn=len;
	}
   else  cn=dkread(lib, *adr, send->buf,1,len);
   if(cn<len)idxdscpt=I_ErrStru;
   send->len=cn;
   send->buf[cn]=0;  /* this time buf point to change */
   }
   return send->buf;
 }
return NULL;
}

void ReadStat(RunTimLib *lib, DIRE *dir,BYTE *stat,MAU *send,int n)
{
memset(send,0,n*sizeof(MAU));/* as return value, so do here */
if(stat&&n>0){
  int i=(GetDirShadow(dir,lib))->_DAU;
  if(n>i)n=i;
  for(i=0;i<n;i++)ReadDAU(lib,dir,stat,send+i,i);
}
}

BYTE *NumbRead(RunTimLib *lib, DIRE *dir,_Long numb,MAU *send, int n, int msg)
{
BYTE *stat=StatSeek(lib,dir,numb,NULL,NUMB_READ|msg );
ReadStat(lib,dir,stat,send,n);
if(stat && (msg&FREE_READ) )free(stat);
return stat;
}

void WriteDAU(RunTimLib *lib,DIRE *dir,BYTE *unit,MAU *Snd, int idx)
{/* write one DAU */
DirShadow *pdp=GetDirShadow(dir,lib);
if(Snd&&Snd->buf){/* type: Po_Int must take in kernel */
  un_Int len, tlen;
  _Long *padr=GetLenDAU(pdp,unit,&len,&tlen,idx);
  SetLenDAU(pdp,unit,Snd->len,idx,1/* set DAU len */);
  if(Snd->len<=DAUsave&&tlen<=DAUsave){
	memcpy(padr, Snd->buf, Snd->len);
	SetLenDAU(pdp,unit, Snd->len, idx, 0/* set DAU alen */);
	}
  else {
	if(*unit==1/*||isZero(pdp->Format)*/){
		if(dir)dir->sz-=len;
		lib->usesize-=len;
		} /* overwrite */
	if(tlen<Snd->len){
		SetLenDAU(pdp,unit,Snd->len,idx,0);  /* set DAU tlen */
		*padr=lib->fsz;
		lib->fsz+=Snd->len;
	 }
	if(dir)dir->sz+=Snd->len;/*!! sz is tab data's size,not disksize, deffenct lib->fsz */
	lib->usesize += Snd->len;
	dkwrite(lib,*padr,Snd->buf,Snd->len);
         }
  }
else SetLenDAU(pdp,unit,0,idx,1/* set DAU len=0 */);
}

BYTE *WriteInit(RunTimLib *lib,DIRE *dir,_Long numb,MAU *send,int n, int msg)
{
  int i;
  BYTE *stat;
  DirShadow *pdp=GetDirShadow(dir,lib);
  for(i=0;i<n;i++)if(send+i){
	if(send[i].buf==NULL)send[i].len=0;
	else if(send[i].len==0)send[i].len=strlen(send[i].buf);
	if(send[i].len>0xfffe)send[i].len=0xfffe;
	}
  stat=StatSeek(lib,dir,numb,send,NUMB_WRITE|msg );
  if(stat&&isZero(pdp->Format)==0)
	*((long *)(stat+statNumPos))=numb;
  return stat;
}

void StatLnkWord(RunTimLib *lib,DIRE *dir,_Int *cnt,_Int len)
{
dkwrite(lib,lib->LNKDWORD,&lib->fsz, sizeof(_Long));
lib->statpos=lib->fsz;
AppCSB(lib, dir, len, cnt, sizeof(_Long));/* creat stat-blank */
}

void WriteStat(RunTimLib *lib,DIRE *dir,BYTE *stat,MAU *send,int n)
{
 DirShadow *pdp=GetDirShadow(dir,lib);
 _Int stlen=pdp->n_statLen,
     c_n_unit=pdp->num_stats_block,
     zero=isZero(pdp->Format);
 un_Int len=stlen * c_n_unit + sizeof(_Long);
 int i, cn;
 if(lib->statpos==0){
   if(zero){
     i=pdp->_numb_+1;
     cn=i/c_n_unit+(i%c_n_unit? 1:0)-lib->CSB_calc;
     i=0;
     while(i++ < cn){
	StatLnkWord(lib,dir,NULL,len);
	lib->LNKDWORD=lib->fsz-sizeof(_Long);
	}
     cn=pdp->_numb_%c_n_unit;
     lib->statpos+=stlen*cn;
#ifndef _NONE_FAST_PAGE_
     SetPgBuf(lib,dir,lib->zdpbuf,lib->statpos-cn*stlen,pdp->_numb_-cn);
#endif
    }
   else StatLnkWord(lib,dir,NULL,len);
 }
 i=pdp->_DAU;
 if(n>i)n=i;
 len=0;
 for(i=0;i<n;i++){
	WriteDAU(lib,dir,stat,send+i,i);
	len+=send[i].len;
	}
 if(len>0){
	SetChgflg(lib,dir,lib->msg_OL? 0:1,1);
/* idxdscpt is extern, it would be change by other func, such as getmanu */
	*stat=1;
	dkwrite(lib,lib->statpos,stat,stlen);
	}
	free(stat);
}

BYTE *NumbWrite(RunTimLib *lib,DIRE *dir,_Long numb,MAU *send, int n, int msg)
{
  BYTE *stat=WriteInit(lib,dir,numb,send,n, msg);
  if(stat)WriteStat(lib,dir,stat,send,n);
  return stat;
}

void ChgStat(RunTimLib *lib,DIRE *dir,BYTE *stat,_Long pos,_Int step,_Int dirflg)
{
  DirShadow *pdp=GetDirShadow(dir,lib);
  un_Int i;
  for(i=0;i<pdp->_DAU;i++)chgsize(lib,dir,stat,step,i);
  SetChgflg(lib,dir,step,dirflg);
  dkwrite(lib,pos,stat,1);
}

